'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRouterDom = require('react-router-dom');

var _RoutePreloader = require('./RoutePreloader');

var _RoutePreloader2 = _interopRequireDefault(_RoutePreloader);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var UniversalRoute = function (_Component) {
  _inherits(UniversalRoute, _Component);

  function UniversalRoute(props) {
    var _this2 = this;

    _classCallCheck(this, UniversalRoute);

    var _this = _possibleConstructorReturn(this, (UniversalRoute.__proto__ || Object.getPrototypeOf(UniversalRoute)).call(this, props));

    _this.resolveBundle = _asyncToGenerator(regeneratorRuntime.mark(function _callee() {
      var bundle, resolved;
      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              bundle = _this.props.bundle;

              if (!bundle) {
                _context.next = 6;
                break;
              }

              _context.next = 4;
              return bundle.load();

            case 4:
              resolved = _context.sent;

              _this.setState({ mod: resolved.default });

            case 6:
            case 'end':
              return _context.stop();
          }
        }
      }, _callee, _this2);
    }));

    _this.state = { mod: props.component };
    return _this;
  }

  _createClass(UniversalRoute, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.resolveBundle();
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          component = _props.component,
          rest = _objectWithoutProperties(_props, ['component']);

      var mod = this.state.mod;


      if (!mod) {
        return _react2.default.createElement(
          'div',
          null,
          'Loading'
        );
      }

      return _react2.default.createElement(_reactRouterDom.Route, _extends({}, rest, { component: (0, _RoutePreloader2.default)(mod, rest) }));
    }
  }]);

  return UniversalRoute;
}(_react.Component);

exports.default = UniversalRoute;